## ros-foxy-rclcpp-components 2.4.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rclcpp_components)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic -Wnon-virtual-dtor -Woverloaded-virtual)
endif()

find_package(ament_cmake_ros REQUIRED)
find_package(ament_index_cpp REQUIRED)
find_package(class_loader REQUIRED)
find_package(composition_interfaces REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rcpputils REQUIRED)

add_library(
  component_manager
  SHARED
  src/component_manager.cpp
)
target_include_directories(component_manager PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include>")
ament_target_dependencies(component_manager
  "ament_index_cpp"
  "class_loader"
  "composition_interfaces"
  "rclcpp"
  "rcpputils"
)
target_compile_definitions(component_manager
  PRIVATE "RCLCPP_COMPONENTS_BUILDING_LIBRARY")

add_executable(
  component_container
  src/component_container.cpp
)
target_link_libraries(component_container component_manager)
ament_target_dependencies(component_container
  "rclcpp"
)

set(node_main_template_install_dir "share/${PROJECT_NAME}")
install(FILES
  src/node_main.cpp.in
  DESTINATION ${node_main_template_install_dir})

add_executable(
  component_container_mt
  src/component_container_mt.cpp
)
target_link_libraries(component_container_mt component_manager)
ament_target_dependencies(component_container_mt
  "rclcpp"
)

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  target_link_libraries(component_container "stdc++fs")
  target_link_libraries(component_container_mt "stdc++fs")
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  find_package(ament_cmake_google_benchmark REQUIRED)
  find_package(benchmark REQUIRED)
  # Give cppcheck hints about macro definitions coming from outside this package
  get_target_property(ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS benchmark::benchmark INTERFACE_INCLUDE_DIRECTORIES)
  ament_lint_auto_find_test_dependencies()

  set(components "")
  add_library(test_component SHARED test/components/test_component.cpp)
  target_include_directories(test_component PUBLIC include)
  ament_target_dependencies(test_component
    "class_loader"
    "rclcpp")
  #rclcpp_components_register_nodes(test_component "test_rclcpp_components::TestComponent")
  set(components "${components}test_rclcpp_components::TestComponentFoo;$<TARGET_FILE:test_component>\n")
  set(components "${components}test_rclcpp_components::TestComponentBar;$<TARGET_FILE:test_component>\n")
  set(components "${components}test_rclcpp_components::TestComponentNoNode;$<TARGET_FILE:test_component>\n")

  # A properly formed resource only has one ';', this is used to catch an invalid resource entry
  set(invalid_components "test_rclcpp_components::TestComponentFoo;;$<TARGET_FILE:test_component>\n")

  file(GENERATE
    OUTPUT
    "${CMAKE_CURRENT_BINARY_DIR}/test_ament_index/$<CONFIG>/share/ament_index/resource_index/rclcpp_components/${PROJECT_NAME}"
    CONTENT "${components}")

  file(GENERATE
    OUTPUT
    "${CMAKE_CURRENT_BINARY_DIR}/test_ament_index/$<CONFIG>/share/ament_index/resource_index/rclcpp_components/invalid_${PROJECT_NAME}"
    CONTENT "${invalid_components}")

  set(append_library_dirs "${CMAKE_CURRENT_BINARY_DIR}")
  if(WIN32)
    set(append_library_dirs "${append_library_dirs}/$<CONFIG>")
  endif()

  ament_add_gtest(test_component_manager test/test_component_manager.cpp
    APPEND_ENV AMENT_PREFIX_PATH=${CMAKE_CURRENT_BINARY_DIR}/test_ament_index/$<CONFIG>
    APPEND_LIBRARY_DIRS "${append_library_dirs}")
  if(TARGET test_component_manager)
    target_link_libraries(test_component_manager component_manager)
  endif()

  ament_add_gtest(test_component_manager_api test/test_component_manager_api.cpp
    APPEND_ENV AMENT_PREFIX_PATH=${CMAKE_CURRENT_BINARY_DIR}/test_ament_index/$<CONFIG>
    APPEND_LIBRARY_DIRS "${append_library_dirs}")
  if(TARGET test_component_manager_api)
    target_link_libraries(test_component_manager_api component_manager)
  endif()

  ament_add_google_benchmark(benchmark_components
    test/benchmark/benchmark_components.cpp
    APPEND_ENV AMENT_PREFIX_PATH=${CMAKE_CURRENT_BINARY_DIR}/test_ament_index/$<CONFIG>
    APPEND_LIBRARY_DIRS "${append_library_dirs}")
  if(TARGET benchmark_components)
    target_link_libraries(benchmark_components component_manager)
  endif()
endif()

install(
  TARGETS component_manager EXPORT component_manager
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

# Install executables
install(
  TARGETS component_container component_container_mt
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

# Install include directories
install(
  DIRECTORY include/
  DESTINATION include
)

# Install cmake
install(
  DIRECTORY cmake
  DESTINATION share/${PROJECT_NAME}
)

# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_libraries(component_manager)
ament_export_targets(component_manager)
ament_export_dependencies(ament_index_cpp)
ament_export_dependencies(class_loader)
ament_export_dependencies(composition_interfaces)
ament_export_dependencies(rclcpp)
ament_package(CONFIG_EXTRAS rclcpp_components-extras.cmake.in)

=== debian/changelog ===
ros-foxy-rclcpp-components (2.4.3-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Sat, 27 May 2023 00:00:00 -0000

ros-foxy-rclcpp-components (2.4.2-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Mon, 25 Jul 2022 00:00:00 -0000

ros-foxy-rclcpp-components (2.4.1-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Mon, 31 Jan 2022 00:00:00 -0000

ros-foxy-rclcpp-components (2.4.0-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Wed, 01 Sep 2021 00:00:00 -0000

ros-foxy-rclcpp-components (2.3.1-1focal) focal; urgency=high

  * Update quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#1616 <https://github.com/ros2/rclcpp/issues/1616>)
  * Contributors: Simon Honigmann

 -- Michael Carroll <michael@openrobotics.org>  Wed, 14 Apr 2021 00:00:00 -0000

ros-foxy-rclcpp-components (2.3.0-1focal) focal; urgency=high

  * Update QD to QL 1 (#1480 <https://github.com/ros2/rclcpp/issues/1480>)
  * Add benchmarks for components (#1479 <https://github.com/ros2/rclcpp/issues/1479>)
  * Contributors: Alejandro Hernández Cordero, Louise Poubel, Scott K Logan, Stephen Brawner

 -- Michael Carroll <michael@openrobotics.org>  Wed, 09 Dec 2020 00:00:00 -0000

ros-foxy-rclcpp-components (2.2.0-1focal) focal; urgency=high

  * Include original exception in ComponentManagerException (#1157 <https://github.com/ros2/rclcpp/issues/1157>) (#1223 <https://github.com/ros2/rclcpp/issues/1223>)
  * Contributors: Dereck Wonnacott

 -- Michael Carroll <michael@openrobotics.org>  Wed, 07 Oct 2020 00:00:00 -0000

ros-foxy-rclcpp-components (2.1.0-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Mon, 03 Aug 2020 00:00:00 -0000

ros-foxy-rclcpp-components (2.0.2-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Tue, 07 Jul 2020 00:00:00 -0000

ros-foxy-rclcpp-components (2.0.1-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Tue, 23 Jun 2020 00:00:00 -0000

ros-foxy-rclcpp-components (2.0.0-1focal) focal; urgency=high

  * Added missing virtual destructors (#1149 <https://github.com/ros2/rclcpp/issues/1149>)
  * Add Security Vulnerability Policy pointing to REP-2006 (#1130 <https://github.com/ros2/rclcpp/issues/1130>)
  * Contributors: Chris Lalancette, Ivan Santiago Paunovic

 -- Michael Carroll <michael@openrobotics.org>  Mon, 01 Jun 2020 00:00:00 -0000

ros-foxy-rclcpp-components (1.1.0-1focal) focal; urgency=high

  * Improve documentation (#1106 <https://github.com/ros2/rclcpp/issues/1106>)
  * Fixed rep links and added more details to dependencies in quality declaration (#1116 <https://github.com/ros2/rclcpp/issues/1116>)
  * Added dockblock to ComponentManager class (#1102 <https://github.com/ros2/rclcpp/issues/1102>)
  * Update quality declaration to reflect version 1.0 (#1115 <https://github.com/ros2/rclcpp/issues/1115>)
  * Contributors: Alejandro Hernández Cordero, Stephen Brawner

 -- Michael Carroll <michael@openrobotics.org>  Tue, 26 May 2020 00:00:00 -0000

ros-foxy-rclcpp-components (1.0.0-1focal) focal; urgency=high

  * Increasing test coverage of rclcpp_components (#1044 <https://github.com/ros2/rclcpp/issues/1044>)
    * Increasing test coverage of rclcpp_components
    Signed-off-by: Stephen Brawner <mailto:brawner@gmail.com>
    * PR fixup
    Signed-off-by: Stephen Brawner <mailto:brawner@gmail.com>
    * Fixup
    Signed-off-by: Stephen Brawner <mailto:brawner@gmail.com>
    * Removing throws test for now
    Signed-off-by: Stephen Brawner <mailto:brawner@gmail.com>
  * Contributors: brawner

 -- Michael Carroll <michael@openrobotics.org>  Tue, 12 May 2020 00:00:00 -0000

ros-foxy-rclcpp-components (0.9.1-1focal) focal; urgency=high

  * Added Quality declaration: rclcpp, rclpp_action, rclcpp_components andrclcpp_lifecycle (#1100 <https://github.com/ros2/rclcpp/issues/1100>)
  * Contributors: Alejandro Hernández Cordero

 -- Michael Carroll <michael@openrobotics.org>  Fri, 08 May 2020 00:00:00 -0000

ros-foxy-rclcpp-components (0.9.0-1focal) focal; urgency=high

  * Added rclcpp_components Doxyfile (#1091 <https://github.com/ros2/rclcpp/issues/1091>)
  * Deprecate redundant namespaces (#1083 <https://github.com/ros2/rclcpp/issues/1083>)
  * Export targets in addition to include directories / libraries (#1088 <https://github.com/ros2/rclcpp/issues/1088>)
  * Export component manager (#1070 <https://github.com/ros2/rclcpp/issues/1070>)
  * Install the component_manager library (#1068 <https://github.com/ros2/rclcpp/issues/1068>)
  * Make Component Manager public (#1065 <https://github.com/ros2/rclcpp/issues/1065>)
  * Remove absolute path from installed CMake code (#948 <https://github.com/ros2/rclcpp/issues/948>)
  * Fix function docblock, check for unparsed arguments (#945 <https://github.com/ros2/rclcpp/issues/945>)
  * Contributors: Alejandro Hernández Cordero, DensoADAS, Dirk Thomas, Jacob Perron, Karsten Knese, Michael Carroll, William Woodall

 -- Michael Carroll <michael@openrobotics.org>  Wed, 29 Apr 2020 00:00:00 -0000

ros-foxy-rclcpp-components (0.8.3-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Tue, 19 Nov 2019 00:00:00 -0000

ros-foxy-rclcpp-components (0.8.2-1focal) focal; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Mon, 18 Nov 2019 00:00:00 -0000

ros-foxy-rclcpp-components (0.8.1-1focal) focal; urgency=high

  * Enable intra-process comm via LoadNode request. (#871 <https://github.com/ros2/rclcpp/issues/871>)
  * Aggregate all component manager API tests. (#876 <https://github.com/ros2/rclcpp/issues/876>)
  * Contributors: Michel Hidalgo

 -- Michael Carroll <michael@openrobotics.org>  Wed, 23 Oct 2019 00:00:00 -0000

ros-foxy-rclcpp-components (0.8.0-1focal) focal; urgency=high



=== debian/control ===
Source: ros-foxy-rclcpp-components
Section: misc
Priority: optional
Maintainer: Michael Carroll <michael@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake-google-benchmark <!nocheck>, ros-foxy-ament-cmake-gtest <!nocheck>, ros-foxy-ament-cmake-ros, ros-foxy-ament-index-cpp, ros-foxy-ament-lint-auto <!nocheck>, ros-foxy-ament-lint-common <!nocheck>, ros-foxy-class-loader, ros-foxy-composition-interfaces, ros-foxy-launch-testing <!nocheck>, ros-foxy-rclcpp, ros-foxy-rcpputils, ros-foxy-std-msgs <!nocheck>, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-rclcpp-components
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-ament-index-cpp, ros-foxy-class-loader, ros-foxy-composition-interfaces, ros-foxy-rclcpp, ros-foxy-ros-workspace
Description: Package containing tools for dynamically loadable components

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rclcpp-components//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
